#include "differential.h"

#ifndef LINUX
__prog__ __attribute__((space(prog))) const float diff_curve[724] = {
#else
const float diff_curve[724] = {
#endif
    0.0095, 0.0094, 0.0092, 0.0090, 0.0089, 0.0087,
    0.0085, 0.0084, 0.0082, 0.0080, 0.0079, 0.0077, 0.0076, 0.0074, 0.0073,
    0.0071, 0.0070, 0.0068, 0.0067, 0.0065, 0.0064, 0.0062, 0.0061, 0.0059,
    0.0058, 0.0057, 0.0055, 0.0054, 0.0053, 0.0051, 0.0050, 0.0049, 0.0048,
    0.0046, 0.0045, 0.0044, 0.0043, 0.0042, 0.0040, 0.0039, 0.0038, 0.0037,
    0.0036, 0.0035, 0.0034, 0.0033, 0.0032, 0.0031, 0.0029, 0.0028, 0.0027,
    0.0027, 0.0026, 0.0025, 0.0024, 0.0023, 0.0022, 0.0021, 0.0020, 0.0019,
    0.0018, 0.0018, 0.0017, 0.0016, 0.0015, 0.0014, 0.0014, 0.0013, 0.0012,
    0.0011, 0.0011, 0.0010, 0.0009, 0.0009, 0.0008, 0.0008, 0.0007, 0.0006,
    0.0006, 0.0005, 0.0005, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0.0005, 0.0005, 0.0006, 0.0006, 0.0007, 0.0008,
    0.0008, 0.0009, 0.0009, 0.0010, 0.0011, 0.0011, 0.0012, 0.0013, 0.0014,
    0.0014, 0.0015, 0.0016, 0.0017, 0.0018, 0.0018, 0.0019, 0.0020, 0.0021,
    0.0022, 0.0023, 0.0024, 0.0025, 0.0026, 0.0027, 0.0027, 0.0028, 0.0029,
    0.0031, 0.0032, 0.0033, 0.0034, 0.0035, 0.0036, 0.0037, 0.0038, 0.0039,
    0.0040, 0.0042, 0.0043, 0.0044, 0.0045, 0.0046, 0.0048, 0.0049, 0.0050,
    0.0051, 0.0053, 0.0054, 0.0055, 0.0057, 0.0058, 0.0059, 0.0061, 0.0062,
    0.0064, 0.0065, 0.0067, 0.0068, 0.0070, 0.0071, 0.0073, 0.0074, 0.0076,
    0.0077, 0.0079, 0.0080, 0.0082, 0.0084, 0.0085, 0.0087, 0.0089, 0.0090,
    0.0092, 0.0094, 0.0095,

    0.0207, 0.02047, 0.02024, 0.02001, 0.01978, 0.01955,
    0.01932, 0.01909, 0.01886, 0.01863, 0.0184, 0.01817, 0.01794, 0.01771,
    0.01748, 0.01725, 0.01702, 0.01679, 0.01656, 0.01633, 0.0161, 0.01587,
    0.01564, 0.01541, 0.01518, 0.01495, 0.01472, 0.01449, 0.01426, 0.01403,
    0.0138, 0.01357, 0.01334, 0.01311, 0.01288, 0.01265, 0.01242, 0.01219,
    0.01196, 0.01173, 0.0115, 0.01127, 0.01104, 0.01081, 0.01058, 0.01035,
    0.01012, 0.00989, 0.00966, 0.00943, 0.0092, 0.00897, 0.00874, 0.00851,
    0.00828, 0.00805, 0.00782, 0.00759, 0.00736, 0.00713, 0.0069, 0.00667,
    0.00644, 0.00621, 0.00598, 0.00575, 0.00552, 0.00529, 0.00506, 0.00483,
    0.0046, 0.00437, 0.00414, 0.00391, 0.00368, 0.00345, 0.00322, 0.00299,
    0.00276, 0.00253, 0.0023, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0,

    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0.0023, 0.00253, 0.00276, 0.00299, 0.00322,
    0.00345, 0.00368, 0.00391, 0.00414, 0.00437, 0.0046, 0.00483, 0.00506,
    0.00529, 0.00552, 0.00575, 0.00598, 0.00621, 0.00644, 0.00667, 0.0069,
    0.00713, 0.00736, 0.00759, 0.00782, 0.00805, 0.00828, 0.00851, 0.00874,
    0.00897, 0.0092, 0.00943, 0.00966, 0.00989, 0.01012, 0.01035, 0.01058,
    0.01081, 0.01104, 0.01127, 0.0115, 0.01173, 0.01196, 0.01219, 0.01242,
    0.01265, 0.01288, 0.01311, 0.01334, 0.01357, 0.0138, 0.01403, 0.01426,
    0.01449, 0.01472, 0.01495, 0.01518, 0.01541, 0.01564, 0.01587, 0.0161,
    0.01633, 0.01656, 0.01679, 0.01702, 0.01725, 0.01748, 0.01771, 0.01794,
    0.01817, 0.0184, 0.01863, 0.01886, 0.01909, 0.01932, 0.01955, 0.01978,
    0.02001, 0.02024, 0.02047, 0.0207
};

float get_diff_curve_value(uint16_t motor, int16_t angle)
{
    if (angle > 90) {
        return 1000 * diff_curve[motor * 181 + 180];
    } else if (angle < -90) {
        return 1000 * diff_curve[motor * 181];
    }

    return 1000 * diff_curve[motor * 181 + angle + 90];
}
